## pcre2 10.39-3ubuntu0.1%2B11.0trisquel0

=== debian/control ===
Source: pcre2
Section: libs
Priority: optional
Maintainer: Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>
XSBC-Original-Maintainer:  Matthew Vernon <matthew@debian.org>
Standards-Version: 4.5.1
Build-Depends: debhelper (>=9), dpkg-dev (>= 1.16.1~)
Vcs-Git: https://salsa.debian.org/debian/pcre2.git
Vcs-Browser: https://salsa.debian.org/debian/pcre2
Homepage: https://pcre.org/

Package: libpcre2-8-0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Description: New Perl Compatible Regular Expression Library- 8 bit runtime files
 This is PCRE2, the new implementation of PCRE, a library of functions
 to support regular expressions whose syntax and semantics are as
 close as possible to those of the Perl 5 language. New projects
 should use this library in preference to the older library,
 confusingly called pcre3 in Debian.
 .
 This package contains the 8 bit runtime library, which operates on
 ASCII and UTF-8 input.

Package: libpcre2-8-0-udeb
Package-Type: udeb
Section: debian-installer
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: New Perl Compatible Regular Expression Library- 8 bit runtime files (udeb)
 This package contains the 8 bit runtime library, for the Debian Installer.

Package: libpcre2-16-0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Description: New Perl Compatible Regular Expression Library - 16 bit runtime files
 This is PCRE2, the new implementation of PCRE, a library of functions
 to support regular expressions whose syntax and semantics are as
 close as possible to those of the Perl 5 language. New projects
 should use this library in preference to the older library,
 confusingly called pcre3 in Debian.
 .
 This package contains the 16 bit runtime library, which operates on
 UTF-16 input.

Package: libpcre2-32-0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Description: New Perl Compatible Regular Expression Library - 32 bit runtime files
 This is PCRE2, the new implementation of PCRE, a library of functions
 to support regular expressions whose syntax and semantics are as
 close as possible to those of the Perl 5 language. New projects
 should use this library in preference to the older library,
 confusingly called pcre3 in Debian.
 .
 This package contains the 32 bit runtime library, which operates on
 UTF-32 input.

Package: libpcre2-posix3
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Replaces: libpcre2-posix0
Conflicts: libpcre2-posix0
Description: New Perl Compatible Regular Expression Library - posix-compatible runtime files
 This is PCRE2, the new implementation of PCRE, a library of functions
 to support regular expressions whose syntax and semantics are as
 close as possible to those of the Perl 5 language. New projects
 should use this library in preference to the older library,
 confusingly called pcre3 in Debian.
 .
 This package contains the runtime library for the posix-compatible API.

Package: libpcre2-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Conflicts: libpcre3-dev (<<2:8.35-8)
Depends: libc-dev, libpcre2-8-0 (= ${binary:Version}), libpcre2-16-0 (= ${binary:Version}), libpcre2-32-0 (= ${binary:Version}), libpcre2-posix3 (= ${binary:Version}), ${misc:Depends}
Description: New Perl Compatible Regular Expression Library - development files
 This is PCRE2, the new implementation of PCRE, a library of functions
 to support regular expressions whose syntax and semantics are as
 close as possible to those of the Perl 5 language. New projects
 should use this library in preference to the older library,
 confusingly called pcre3 in Debian.
 .
 This package contains the development files, including headers,
 static libraries, and documentation.

Package: pcre2-utils
Section: utils
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: New Perl Compatible Regular Expression Library - utilities
 This is PCRE2, the new implementation of PCRE, a library of functions
 to support regular expressions whose syntax and semantics are as
 close as possible to those of the Perl 5 language. New projects
 should use this library in preference to the older library,
 confusingly called pcre3 in Debian.
 .
 This package contains the utilities pcre2grep (like grep with PCRE)
 and pcre2test (a test program for the library, but also useful for
 experimenting with regular expressions). Both programs are also
 useful examples of programming with libpcre2.
