## pcre2 10.39-3ubuntu0.1+11.0trisquel0

=== debian/changelog ===
pcre2 (10.39-3ubuntu0.1+11.0trisquel0) aramo-security; urgency=medium

  * Fetch and build as udeb dependency for debian-installer.

 -- Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>  Tue, 01 Nov 2022 15:18:54 +0000

pcre2 (10.39-3ubuntu0.1) jammy-security; urgency=medium

  * SECURITY UPDATE: out-of-bounds read in pcre2_jit_compile
    - Fix a unicode property matching issue and an incorrect
      value reading in JIT in src/pcre2_jit_compile.c and
      src/pcre2_jit_test.c.
    - Fix a recursions issue in JIT caused by duplicated
      data transfers in src/pcre2_jit_compile.c and
      src/pcre2_jit_test.c.
    - CVE-2022-1586
    - CVE-2022-1587 

 -- David Fernandez Gonzalez <david.fernandezgonzalez@canonical.com>  Tue, 20 Sep 2022 12:46:17 +0200

pcre2 (10.39-3build1) jammy; urgency=high

  * No change rebuild for ppc64el baseline bump.

 -- Julian Andres Klode <juliank@ubuntu.com>  Thu, 24 Mar 2022 17:22:31 +0100

pcre2 (10.39-3) unstable; urgency=medium

  * Enable JIT on s390x (Closes: #999836)
  * Re-enable JIT on MIPS (Closes: #892488)

 -- Matthew Vernon <matthew@debian.org>  Wed, 17 Nov 2021 14:52:42 +0000

pcre2 (10.39-2) unstable; urgency=medium

  * Update long descriptions of runtime packages (Closes: #978013)
  * Source-only upload (-1 was binary to get through NEW)
  * Depend on libc-dev rather than libc6-dev (Closes: #989729)

 -- Matthew Vernon <matthew@debian.org>  Mon, 08 Nov 2021 23:47:21 +0000

pcre2 (10.39-1) unstable; urgency=medium

  * New upstream release
  * Update watch file to reflect new upstream home on github
  * libpcre2-posix soname updated

 -- Matthew Vernon <matthew@debian.org>  Sat, 06 Nov 2021 13:56:27 +0000
