## pcre2 10.42-4ubuntu2.1trisquel0

=== debian/changelog ===
pcre2 (10.42-4ubuntu2.1trisquel0) ecne; urgency=medium

  * Fetch and build as udeb dependency for debian-installer.

 -- Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>  Tue, 28 Jan 2025 16:45:19 +0000

pcre2 (10.42-4ubuntu2.1) noble; urgency=medium

  * SRU: LP: #2083480: No-change rebuild to disable frame pointers on
    ppc64el and s390x.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 02 Oct 2024 14:40:51 +0200

pcre2 (10.42-4ubuntu2) noble; urgency=high

  * No change rebuild for 64-bit time_t and frame pointers.

 -- Julian Andres Klode <juliank@ubuntu.com>  Mon, 08 Apr 2024 18:15:28 +0200

pcre2 (10.42-4ubuntu1) noble; urgency=medium

  * Disable JIT on riscv64 for now, regressing all
    kde packages
  * Enable testsuite on riscv64

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sun, 10 Dec 2023 20:39:53 +0100

pcre2 (10.42-4) unstable; urgency=medium

  * Build with JIT support on riscv64 (Closes: #1050819)

 -- Matthew Vernon <matthew@debian.org>  Tue, 29 Aug 2023 18:23:44 +0100

pcre2 (10.42-3) unstable; urgency=medium

  * Specify source format 1.0 explicitly (Closes: #1049910)

 -- Matthew Vernon <matthew@debian.org>  Mon, 21 Aug 2023 11:44:09 +0100

pcre2 (10.42-2) unstable; urgency=medium

  * disable JIT on sparc (Closes: #1034779)

 -- Matthew Vernon <matthew@debian.org>  Tue, 11 Jul 2023 23:11:09 +0100

pcre2 (10.42-1) unstable; urgency=medium

  * New upstream version

 -- Matthew Vernon <matthew@debian.org>  Sun, 01 Jan 2023 15:44:06 +0000

pcre2 (10.40-3) unstable; urgency=medium

  * Support the noudeb build profile (Helmut Grohne). (Closes: #1024941)

 -- Matthew Vernon <matthew@debian.org>  Fri, 02 Dec 2022 17:40:13 +0000

pcre2 (10.40-2) unstable; urgency=low

  * Move to machine-readable copyright file (Bastian Germann)
  * Remove filenamemangle from debian/watch (Bastian Germann)

 -- Matthew Vernon <matthew@debian.org>  Sun, 23 Oct 2022 16:07:18 +0100

pcre2 (10.40-1) unstable; urgency=medium

  * New upstream release
  * Update watch file to note new upstream repo location

 -- Matthew Vernon <matthew@debian.org>  Mon, 25 Apr 2022 17:10:36 +0100

pcre2 (10.39-4) unstable; urgency=medium

  * Backport upstream Hurd build fix (Closes: #1009066)

 -- Matthew Vernon <matthew@debian.org>  Mon, 11 Apr 2022 09:23:48 +0100
