=== debian/control ===
--- 
+++ 
@@ -27,6 +27,7 @@
 
 Package: libpcre2-8-0-udeb
 Package-Type: udeb
+Build-Profiles: <!noudeb>
 Section: debian-installer
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
