=== debian/rules ===
--- 
+++ 
@@ -10,10 +10,16 @@
 # ones in libc.
 export DEB_CFLAGS_MAINT_APPEND = -Dregcomp=PCRE2regcomp -Dregexec=PCRE2regexec -Dregerror=PCRE2regerror -Dregfree=PCRE2regfree
 
+ifeq ($(DEB_HOST_ARCH),riscv64)
+ifeq ($(DEB_BUILD_ARCH),riscv64)
+# Force testsuite on riscv64
+DEB_BUILD_OPTIONS := $(filter-out nocheck,$(DEB_BUILD_OPTIONS))
+endif
+endif
 
 deb_maint_conf_args = --enable-pcre2-16 --enable-pcre2-32 --disable-pcre2grep-callout
 #enable JIT only on architectures that support it (see pcre2jit.3)
-ifneq ($(filter i386 amd64 armel armhf mips mipsel mips64el powerpc sparc arm64 ppc64 ppc64el s390x, $(DEB_HOST_ARCH)),)
+ifneq ($(filter amd64 armel armhf arm64 i386 mips mipsel mips64el powerpc ppc64 ppc64el s390x, $(DEB_HOST_ARCH)),)
 deb_maint_conf_args +=--enable-jit
 else
 deb_maint_conf_args +=--disable-jit
