## pcre2 10.46

=== CMakeLists.txt ===
--- 
+++ 
@@ -100,11 +100,25 @@
 # 2021-08-28 PH increased minimum version
 # 2021-08-28 PH added test for realpath()
 # 2022-12-10 PH added support for pcre2posix_test
-
-# Increased minimum to 2.8.5 to support GNUInstallDirs.
-# Increased minimum to 3.1 to support imported targets.
-CMAKE_MINIMUM_REQUIRED(VERSION 3.1)
-PROJECT(PCRE2 C)
+# 2023-01-15 Carlo added C99 as the minimum required
+# 2023-08-06 PH added support for setting variable length lookbehind maximum
+
+################################################################################
+# We have used `gersemi` for auto-formatting our CMake files.
+# Applied to all CMake files using:
+#    > pip3 install gersemi
+#    > gersemi --in-place --line-length 120 --indent 2 \
+#          ./CMakeLists.txt ./cmake/*.cmake ./cmake/*.cmake.in
+################################################################################
+
+# Increased minimum to 3.15 to allow use of string(REPEAT).
+cmake_minimum_required(VERSION 3.15 FATAL_ERROR)
+project(PCRE2 C)
+set(CMAKE_C_STANDARD 99)
+set(CMAKE_C_STANDARD_REQUIRED TRUE)
+
+set(CMAKE_C_VISIBILITY_PRESET hidden)
+cmake_policy(SET CMP0063 NEW)
 
 # Set policy CMP0026 to avoid warnings for the use of LOCATION in
 # GET_TARGET_PROPERTY. This should no longer be required.
@@ -119,152 +133,173 @@
 # on the command line.
 # SET(CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake)
 
-LIST(APPEND CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake)
-
-INCLUDE_DIRECTORIES(${PROJECT_SOURCE_DIR}/src)
+list(APPEND CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake)
+
+include_directories(${PROJECT_SOURCE_DIR}/src)
 
 # external packages
-FIND_PACKAGE( BZip2 )
-FIND_PACKAGE( ZLIB )
-FIND_PACKAGE( Readline )
-FIND_PACKAGE( Editline )
+find_package(BZip2)
+find_package(ZLIB)
+find_package(Readline)
+find_package(Editline)
 
 # Configuration checks
 
-INCLUDE(CheckCSourceCompiles)
-INCLUDE(CheckFunctionExists)
-INCLUDE(CheckSymbolExists)
-INCLUDE(CheckIncludeFile)
-INCLUDE(CheckTypeSize)
-INCLUDE(GNUInstallDirs) # for CMAKE_INSTALL_LIBDIR
-
-CHECK_INCLUDE_FILE(dirent.h     HAVE_DIRENT_H)
-CHECK_INCLUDE_FILE(sys/stat.h   HAVE_SYS_STAT_H)
-CHECK_INCLUDE_FILE(sys/types.h  HAVE_SYS_TYPES_H)
-CHECK_INCLUDE_FILE(unistd.h     HAVE_UNISTD_H)
-CHECK_INCLUDE_FILE(windows.h    HAVE_WINDOWS_H)
-
-CHECK_SYMBOL_EXISTS(bcopy         "strings.h"  HAVE_BCOPY)
-CHECK_SYMBOL_EXISTS(memfd_create  "sys/mman.h" HAVE_MEMFD_CREATE)
-CHECK_SYMBOL_EXISTS(memmove       "string.h"   HAVE_MEMMOVE)
-CHECK_SYMBOL_EXISTS(secure_getenv "stdlib.h"   HAVE_SECURE_GETENV)
-CHECK_SYMBOL_EXISTS(strerror      "string.h"   HAVE_STRERROR)
-
-CHECK_C_SOURCE_COMPILES(
-  "#include <stdlib.h>
-   #include <limits.h>
-   int main(int c, char *v[]) { char buf[PATH_MAX]; realpath(v[1], buf); return 0; }"
+include(CheckCSourceCompiles)
+include(CheckFunctionExists)
+include(CheckSymbolExists)
+include(CheckIncludeFile)
+include(CheckTypeSize)
+include(GNUInstallDirs) # for CMAKE_INSTALL_LIBDIR
+
+check_include_file(assert.h HAVE_ASSERT_H)
+check_include_file(dirent.h HAVE_DIRENT_H)
+check_include_file(sys/stat.h HAVE_SYS_STAT_H)
+check_include_file(sys/types.h HAVE_SYS_TYPES_H)
+check_include_file(unistd.h HAVE_UNISTD_H)
+check_include_file(windows.h HAVE_WINDOWS_H)
+
+check_symbol_exists(bcopy "strings.h" HAVE_BCOPY)
+check_symbol_exists(memfd_create "sys/mman.h" HAVE_MEMFD_CREATE)
+check_symbol_exists(memmove "string.h" HAVE_MEMMOVE)
+check_symbol_exists(secure_getenv "stdlib.h" HAVE_SECURE_GETENV)
+check_symbol_exists(strerror "string.h" HAVE_STRERROR)
+
+check_c_source_compiles(
+  [=[
+  #include <stdlib.h>
+  #include <limits.h>
+  int main(int c, char *v[]) { char buf[PATH_MAX]; realpath(v[c], buf); return 0; }
+  ]=]
   HAVE_REALPATH
 )
 
 set(ORIG_CMAKE_REQUIRED_FLAGS ${CMAKE_REQUIRED_FLAGS})
-set(CMAKE_REQUIRED_FLAGS "${CMAKE_REQUIRED_FLAGS} -Werror")
-CHECK_C_SOURCE_COMPILES(
-  "int main() { char buf[128] __attribute__((uninitialized)); (void)buf; return 0; }"
+if(NOT MSVC AND NOT CMAKE_C_COMPILER_ID STREQUAL "XL")
+  set(CMAKE_REQUIRED_FLAGS "${CMAKE_REQUIRED_FLAGS} -Werror")
+endif()
+
+check_c_source_compiles(
+  "int main(void) { char buf[128] __attribute__((uninitialized)); (void)buf; return 0; }"
   HAVE_ATTRIBUTE_UNINITIALIZED
 )
+
+check_c_source_compiles(
+  [=[
+  extern __attribute__ ((visibility ("default"))) int f(void);
+  int main(void) { return f(); }
+  int f(void) { return 42; }
+  ]=]
+  HAVE_VISIBILITY
+)
+
 set(CMAKE_REQUIRED_FLAGS ${ORIG_CMAKE_REQUIRED_FLAGS})
+
+check_c_source_compiles("int main(void) { __assume(1); return 0; }" HAVE_BUILTIN_ASSUME)
+
+check_c_source_compiles(
+  [=[
+  #include <stddef.h>
+  int main(void) { int a,b; size_t m; __builtin_mul_overflow(a,b,&m); return 0; }
+  ]=]
+  HAVE_BUILTIN_MUL_OVERFLOW
+)
+
+check_c_source_compiles(
+  "int main(int c, char *v[]) { if (c) __builtin_unreachable(); return (int)(*v[0]); }"
+  HAVE_BUILTIN_UNREACHABLE
+)
+
+if(HAVE_VISIBILITY)
+  set(PCRE2_EXPORT [=[__attribute__ ((visibility ("default")))]=])
+else()
+  set(PCRE2_EXPORT)
+endif()
 
 # Check whether Intel CET is enabled, and if so, adjust compiler flags. This
 # code was written by PH, trying to imitate the logic from the autotools
 # configuration.
 
-CHECK_C_SOURCE_COMPILES(
-  "#ifndef __CET__
-   #error CET is not enabled
-   #endif
-   int main() { return 0; }"
+check_c_source_compiles(
+  [=[
+  #ifndef __CET__
+  #error CET is not enabled
+  #endif
+  int main() { return 0; }
+  ]=]
   INTEL_CET_ENABLED
 )
 
-IF (INTEL_CET_ENABLED)
-  SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -mshstk")
-ENDIF(INTEL_CET_ENABLED)
-
-
+if(INTEL_CET_ENABLED)
+  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -mshstk")
+endif()
 
 # User-configurable options
 #
 # Note: CMakeSetup displays these in alphabetical order, regardless of
 # the order we use here.
 
-SET(BUILD_SHARED_LIBS OFF CACHE BOOL "Build shared libraries.")
-
-OPTION(BUILD_STATIC_LIBS "Build static libraries." ON)
-
-OPTION(PCRE2_BUILD_PCRE2_8 "Build 8 bit PCRE2 library" ON)
-
-OPTION(PCRE2_BUILD_PCRE2_16 "Build 16 bit PCRE2 library" OFF)
-
-OPTION(PCRE2_BUILD_PCRE2_32 "Build 32 bit PCRE2 library" OFF)
-
-OPTION(PCRE2_STATIC_PIC "Build the static library with the option position independent code enabled." OFF)
-
-OPTION(PCRE2_DEBUG "Include debugging code" OFF)
-
-OPTION(PCRE2_DISABLE_PERCENT_ZT "Disable the use of %zu and %td (rarely needed)" OFF)
-
-SET(PCRE2_EBCDIC OFF CACHE BOOL
-    "Use EBCDIC coding instead of ASCII. (This is rarely used outside of mainframe systems.)")
-
-SET(PCRE2_EBCDIC_NL25 OFF CACHE BOOL
-    "Use 0x25 as EBCDIC NL character instead of 0x15; implies EBCDIC.")
-
-SET(PCRE2_LINK_SIZE "2" CACHE STRING
-    "Internal link size (2, 3 or 4 allowed). See LINK_SIZE in config.h.in for details.")
-
-SET(PCRE2_PARENS_NEST_LIMIT "250" CACHE STRING
-    "Default nested parentheses limit. See PARENS_NEST_LIMIT in config.h.in for details.")
-
-SET(PCRE2_HEAP_LIMIT "20000000" CACHE STRING
-    "Default limit on heap memory (kibibytes). See HEAP_LIMIT in config.h.in for details.")
-
-SET(PCRE2_MATCH_LIMIT "10000000" CACHE STRING
-    "Default limit on internal looping. See MATCH_LIMIT in config.h.in for details.")
-
-SET(PCRE2_MATCH_LIMIT_DEPTH "MATCH_LIMIT" CACHE STRING
-    "Default limit on internal depth of search. See MATCH_LIMIT_DEPTH in config.h.in for details.")
-
-SET(PCRE2GREP_BUFSIZE "20480" CACHE STRING
-    "Buffer starting size parameter for pcre2grep. See PCRE2GREP_BUFSIZE in config.h.in for details.")
-
-SET(PCRE2GREP_MAX_BUFSIZE "1048576" CACHE STRING
-    "Buffer maximum size parameter for pcre2grep. See PCRE2GREP_MAX_BUFSIZE in config.h.in for details.")
-
-SET(PCRE2_NEWLINE "LF" CACHE STRING
-    "What to recognize as a newline (one of CR, LF, CRLF, ANY, ANYCRLF, NUL).")
-
-SET(PCRE2_HEAP_MATCH_RECURSE OFF CACHE BOOL
-    "Obsolete option: do not use")
-
-SET(PCRE2_SUPPORT_JIT OFF CACHE BOOL
-    "Enable support for Just-in-time compiling.")
-
-IF(${CMAKE_SYSTEM_NAME} MATCHES Linux|NetBSD)
-    SET(PCRE2_SUPPORT_JIT_SEALLOC OFF CACHE BOOL
-        "Enable SELinux compatible execmem allocator in JIT (experimental).")
-ELSE(${CMAKE_SYSTEM_NAME} MATCHES Linux|NetBSD)
-    SET(PCRE2_SUPPORT_JIT_SEALLOC IGNORE)
-ENDIF(${CMAKE_SYSTEM_NAME} MATCHES Linux|NetBSD)
-
-SET(PCRE2GREP_SUPPORT_JIT ON CACHE BOOL
-    "Enable use of Just-in-time compiling in pcre2grep.")
-
-SET(PCRE2GREP_SUPPORT_CALLOUT ON CACHE BOOL
-    "Enable callout string support in pcre2grep.")
-
-SET(PCRE2GREP_SUPPORT_CALLOUT_FORK ON CACHE BOOL
-    "Enable callout string fork support in pcre2grep.")
-
-SET(PCRE2_SUPPORT_UNICODE ON CACHE BOOL
-    "Enable support for Unicode and UTF-8/UTF-16/UTF-32 encoding.")
-
-SET(PCRE2_SUPPORT_BSR_ANYCRLF OFF CACHE BOOL
-    "ON=Backslash-R matches only LF CR and CRLF, OFF=Backslash-R matches all Unicode Linebreaks")
-
-SET(PCRE2_NEVER_BACKSLASH_C OFF CACHE BOOL
-    "If ON, backslash-C (upper case C) is locked out.")
-
-SET(PCRE2_SUPPORT_VALGRIND OFF CACHE BOOL
-    "Enable Valgrind support.")
-
+set(BUILD_SHARED_LIBS OFF CACHE BOOL "Build shared libraries.")
+
+option(BUILD_STATIC_LIBS "Build static libraries." ON)
+
+option(PCRE2_BUILD_PCRE2_8 "Build 8 bit PCRE2 library" ON)
+
+option(PCRE2_BUILD_PCRE2_16 "Build 16 bit PCRE2 library" OFF)
+
+option(PCRE2_BUILD_PCRE2_32 "Build 32 bit PCRE2 library" OFF)
+
+option(PCRE2_STATIC_PIC "Build the static library with the option position independent code enabled." OFF)
+
+set(PCRE2_DEBUG "IfDebugBuild" CACHE STRING "Include debugging code")
+set_property(CACHE PCRE2_DEBUG PROPERTY STRINGS "IfDebugBuild" "ON" "OFF")
+
+option(PCRE2_DISABLE_PERCENT_ZT "Disable the use of %zu and %td (rarely needed)" OFF)
+
+set(
+  PCRE2_EBCDIC
+  OFF
+  CACHE BOOL
+  "Use EBCDIC coding instead of ASCII. (This is rarely used outside of mainframe systems.)"
+)
+
+set(PCRE2_EBCDIC_NL25 OFF CACHE BOOL "Use 0x25 as EBCDIC NL character instead of 0x15; implies EBCDIC.")
+
+set(
+  PCRE2_LINK_SIZE
+  "2"
+  CACHE STRING
+  "Internal link size (2, 3 or 4 allowed). See LINK_SIZE in config.h.in for details."
+)
+
+set(
+  PCRE2_PARENS_NEST_LIMIT
+  "250"
+  CACHE STRING
+  "Default nested parentheses limit. See PARENS_NEST_LIMIT in config.h.in for details."
+)
+
+set(
+  PCRE2_HEAP_LIMIT
+  "20000000"
+  CACHE STRING
+  "Default limit on heap memory (kibibytes). See HEAP_LIMIT in config.h.in for details."
+)
+
+set(PCRE2_MAX_VARLOOKBEHIND "255" CACHE STRING "Default limit on variable lookbehinds.")
+
+set(
+  PCRE2_MATCH_LIMIT
+  "10000000"
+  CACHE STRING
+  "Default limit on internal looping. See MATCH_LIMIT in config.h.in for details."
+)
+
+set(
+  PCRE2_MATCH_LIMIT_DEPTH
+  "MATCH_LIMIT"
+  CACHE STRING
+  "Default limit on internal depth of search. See MATCH_LIMIT_DEPTH in config.h.in for details."
+)
+
+set(
